package com.dbxml.db.admin.nodes;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: IndexNode.java,v 1.3 2004/02/12 00:17:54 bradford Exp $
 */

import com.dbxml.db.admin.Admin;
import com.dbxml.db.client.CollectionClient;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

/**
 * IndexNode
 */

public final class IndexNode extends AdminNode implements HasMenu, HasCollection {
   private static final Icon IndexIcon = new ImageIcon(IndexNode.class.getResource("index_mini.gif"));

   public static final int ACTION_DROP = 0;

   private CollectionClient col;
   private String id;

   public IndexNode(AdminNode parentNode, CollectionClient col, String id) {
      super(parentNode);

      this.col = col;
      this.id = id;
   }

   public String getLabel() {
      return id;
   }

   public Icon getIcon() {
      return IndexIcon;
   }

   public CollectionClient getCollection() {
      return col;
   }

   public MenuItem[] getMenu() {
      return new MenuItem[] {new MenuItem(ACTION_DROP, "Drop Index")};
   }

   public String getMenuTitle() {
      return "Index";
   }

   public int menuAction(int action) {
      switch ( action ) {
         case ACTION_DROP:
            try {
               String title = "Drop Index";
               String message = "Are you sure you want to drop the\n"
                              + "Index '"+id+"'?";
               int res = JOptionPane.showConfirmDialog(Admin.getInstance(), message, title, JOptionPane.YES_NO_OPTION);
               if ( res == JOptionPane.YES_OPTION ) {
                  col.dropIndexer(id);
                  return REMOVE_SELF;
               }
            }
            catch ( Exception e ) {
               Admin.getInstance().addMessage(e.getMessage());
            }
            break;

      }
      return REFRESH_NONE;
   }
}
